import 'package:equatable/equatable.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import '../../models/response_save_pengantaran_hasil_model.dart';
import '../../provider/dio_provider.dart';
import '../../repository/base_repository.dart';
import '../../repository/pengantaran_hasil_dokter_repository.dart';
import '../../repository/pengantaran_hasil_instansi_repository.dart';

// 3. state provider
final pengantaranHasilCompanySave = StateNotifierProvider<
        PengantaranhasilCompanySaveNotifier, PengantaranhasilCompanySaveState>(
    (ref) => PengantaranhasilCompanySaveNotifier(ref: ref));

// 2. notifier
class PengantaranhasilCompanySaveNotifier
    extends StateNotifier<PengantaranhasilCompanySaveState> {
  final Ref ref;
  PengantaranhasilCompanySaveNotifier({required this.ref})
      : super(PengantaranhasilCompanySaveStateInit());
  void pengantaranHasilCompanySave({
    required String courierID,
    required String tipeID,
    required String deliveryID,
  }) async {
    try {
      state = PengantaranhasilCompanySaveStateLoading();
      final resp =
          await PengantaranHasilInstansiRepository(dio: ref.read(dioProvider))
              .pengantaranHasilInstansiSave(
                courierID: courierID,
                tipeID: tipeID,
                deliveryID: deliveryID
              );

      state = PengantaranhasilCompanySaveStateDone(model: resp);
    } catch (e) {
      if (e is BaseRepositoryException) {
        state = PengantaranhasilCompanySaveStateError(message: e.message ?? "");
      } else {
        state = PengantaranhasilCompanySaveStateError(message: e.toString());
      }
    }
  }
}

// 1. state
abstract class PengantaranhasilCompanySaveState extends Equatable {
  final DateTime date;
  const PengantaranhasilCompanySaveState(this.date);
  @override
  List<Object?> get props => [date];
}

class PengantaranhasilCompanySaveStateInit
    extends PengantaranhasilCompanySaveState {
  PengantaranhasilCompanySaveStateInit() : super(DateTime.now());
}

class PengantaranhasilCompanySaveStateLoading
    extends PengantaranhasilCompanySaveState {
  PengantaranhasilCompanySaveStateLoading() : super(DateTime.now());
}

class PengantaranhasilCompanySaveStateError
    extends PengantaranhasilCompanySaveState {
  final String? message;
  PengantaranhasilCompanySaveStateError({
    required this.message,
  }) : super(DateTime.now());
}

class PengantaranhasilCompanySaveStateDone
    extends PengantaranhasilCompanySaveState {
  final ResponseSavePengantaranHasilModel model;
  PengantaranhasilCompanySaveStateDone({
    required this.model,
  }) : super(DateTime.now());
}
